from zope.i18nmessageid import MessageIDFactory
_ = MessageIDFactory('adytum')

from adytum.z3.types.interfaces import IContent
from adytum.z3.types.interfaces import IContentContainer, IContentContained

from zope.schema import TextLine, Text
from zope.schema import Field

from zope.app.container.constraints import ContainerTypesConstraint
from zope.app.container.constraints import ItemTypePrecondition

class IEquipment(IContent):
    name = TextLine(
        title=_(u"Name"),
        description=_(u"The name of the equipment"),
        required=True
        )
    description = Text(
        title=_(u"Description"),
        description=_(u"The description of the equipment"),
        required=True
        )

class IHeavyConstruction(IEquipment):
    pass

class IEquipmentContainer(IContentContainer):

    def __setitem__(name, object):
        """Add content"""

    __setitem__.precondition = ItemTypePrecondition(IContent)

class IEquipmentContained(IContentContainer):

    __parent__ = Field(
        constraint = ContainerTypesConstraint(IContentContainer)
        )
