import re
from adytum.util.sourceforge import base
from adytum.util.browser import getMatchingLink

def getNewsForm(b, projectName):
    """
    This function gets the browser object representing the form, starting from
    the logged-in (home) page.
    """
    b.getLink(projectName).click()
    b.getLink('News').click()
    getMatchingLink(b, 'Submit', '/news/submit').click()
    return b

def submitNews(b, headline, story):
    """
    The function operates on the browser object representing the SF news form,
    pushing to data to SF.net.
    """
    details = re.sub("\r?\n", "\r\n", story)
    b.getControl(name='summary').value = headline
    b.getControl(name='details').value = details
    b.getControl(name='submit').click()
    return b

def postNews(projectName, credFile, headline, story):
    """
    This function manages the login, gets the form and submits the news data to
    the form.
    """
    loginURL = 'https://sourceforge.net/account/login.php'
    home = base.login(loginURL, credFile=credFile)
    form = getNewsForm(home, projectName)
    return submitNews(form, headline, story)

def getNewsURL(b):
    pass
